////////////////////////////////////////////////////////////////////////////////
///
///		Title		: Mimic partially implement Header File
///
///		Copyright (c) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///		Team		: Desktop Service Development
///
////////////////////////////////////////////////////////////////////////////////
#pragma once

#include <atlcoll.h>
#include "MiniMapInterface.h"
#include "NPCommonUI.h"

/**
* @ingroup 	Common UI	
* @brief 	partially implement IMimic interface
* @date		11/29/2006
* @author	telltale
* @remark	
*/
class NPCOMMONUI_API CAbstractMimic : public IMimic
{
public:
	CAbstractMimic(void);
	virtual ~CAbstractMimic(void);

//override
	/**
	* @brief 	add mimic listener
	* @param	pLister	mimic listener
	* @return	none
	*/
	void AddMimicListener(IMimicListener* pListener);
	/**
	* @brief 	remove mimic listener
	* @param	pLister	mimic listener
	* @return	none
	*/
	void RemoveMimicListener(IMimicListener* pListener);

	/**
	* @brief 	fire ChangeMimic event
	*/
	virtual void Fire_OnChangeMimic();
	/**
	* @brief 	fire PaintMimic event
	*/
	virtual void Fire_OnPaintMimic(BOOL bRedraw = FALSE);

protected:
	///< IMimicListener list
	CAtlList<IMimicListener*>	m_lstMimicListener;
};
